Attribute VB_Name = "basMain"
Option Explicit

Private Declare Function SetWindowPos Lib "user32" (ByVal Hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cX As Long, ByVal cY As Long, ByVal wFlags As Long) As Long
Private Declare Function GetWindowLongA Lib "user32.dll" (ByVal Hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal Hwnd As Long, ByVal nIndex As Long, ByVal dwnewLong As Long) As Long
Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer

Public Declare Function SearchLB Lib "user32" Alias "SendMessageA" (ByVal Hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long

Public Enum ControlDirection
    cdHorizontal = 0
    cdVertical = 1
End Enum

Public Type MYNFO
    Path    As String
    DB      As String
    Name    As String
    Version As String
End Type

Public Cn As ADODB.Connection
Public Rs As ADODB.Recordset

Public My  As MYNFO

Dim CB_AutoCompleteWORK As Boolean

Public Table() As String, myKat As String, F$
Public Edit As Boolean, AddNew As Boolean, tWork As Boolean

Sub Main()

    If App.PrevInstance Then
        Beep
        End
    End If
    
    On Local Error Resume Next
    
    frmMain.Show
    
End Sub
Public Function OpenDatabase(Connection As Object, ByVal DataBasePath As String, _
                             Optional User As String, Optional Password As String) As Long
    
    On Local Error GoTo Quit
    
    With Connection
        .CursorLocation = adUseClient
        .Mode = adModeShareDenyNone
        .Provider = "Microsoft.Jet.OLEDB.4.0"
        .Properties("Data Source") = DataBasePath
        
        If Password <> "" Then .Properties("Password") = Password
        If User <> "" Then .Properties("User") = User
        
        .Open
    End With

Quit:
    OpenDatabase = Err.Number
    
    Err.Clear
    
End Function
Public Function TableList(Cn As Object) As String()
    Dim Rs As Object
    Dim P As Long, X As Long
    Dim R$()
    
    Const adSchemaTables = 20
    
    On Local Error GoTo Quit
    
    Set Rs = Cn.OpenSchema(adSchemaTables)
        
    For P = 0 To Rs.RecordCount - 1
        If Rs.Fields("TABLE_TYPE") = "TABLE" Then
            If Rs.Fields("TABLE_NAME") <> "_Log_" Then
                ReDim Preserve R$(X)
                
                R$(X) = Rs.Fields("TABLE_NAME")
                
                X = X + 1
            End If
        End If
        
        Rs.MoveNext
    Next P
    
    TableList = R$
    
Quit:
    Err.Clear
    
End Function
Public Function SelectTable(Connection As Object, _
                            Recordset As Object, _
                            ByVal Table As String, _
                            Optional SortBy As String = "") As Long
    
    On Local Error Resume Next
    Recordset.Close
    Err.Clear
    On Local Error GoTo Quit
    
    With Recordset
        .ActiveConnection = Connection
        .CursorLocation = adUseClient
        .CursorType = adOpenKeyset
        .LockType = adLockOptimistic
        
        If SortBy = "" Then
            .Source = "SELECT * FROM " & Table
        Else
            .Source = "SELECT * FROM " & Table & " ORDER BY " & SortBy
        End If
        
        .Open
    End With
    
    On Local Error Resume Next
    Recordset.MoveFirst
    Err.Clear
    
Quit:
    SelectTable = Err.Number
        
    Err.Clear
    
End Function
Public Function CloseDataBase(Connection As Object) As Long

    On Local Error GoTo Quit

    Connection.Close
    Set Connection = Nothing
    
Quit:
    CloseDataBase = Err.Number

    Err.Clear
    
End Function
Public Function StayOnTop(ByVal Hwnd As Long, Optional Remove As Boolean) As Boolean
    Dim hWndInsertAfter As Long

    Const HWND_TOPMOST = -1
    Const SWP_NOSIZE = &H1
    Const SWP_NOMOVE = &H2
    Const HWND_NOTOPMOST = -2
    
    hWndInsertAfter = IIf(Remove, HWND_TOPMOST, HWND_NOTOPMOST)

    If SetWindowPos(Hwnd, hWndInsertAfter, 0, 0, 0, 0, SWP_NOSIZE Or SWP_NOMOVE) Then StayOnTop = True
    
End Function
Public Function Control_Roll(Control As Object, xStart As Long, xEnd As Long, _
                             Optional Direction As ControlDirection = cdHorizontal, _
                             Optional RollSpeed As Long = 10) As Long
    Dim P As Long, xStep As Long
        
    On Local Error GoTo Quit

    If xEnd >= xStart Then
        xStep = RollSpeed
    Else
        xStep = (RollSpeed * -1)
    End If
    
    For P = xStart To xEnd Step xStep
        Select Case Direction
            Case cdHorizontal: Control.Width = P
            Case cdVertical:   Control.Height = P
        End Select
        
        Control.Refresh
        
        DoEvents
    Next P

Quit:
    Control_Roll = Err.Number
    
    Err.Clear
    
End Function
Public Sub DeactivateResize(Form As Form)
    Dim lngStyle As Long
    
    Const WS_SIZEBOX = &H40000
    Const GWL_STYLE = -16
    
    lngStyle = GetWindowLongA(Form.Hwnd, GWL_STYLE)
    lngStyle = lngStyle - WS_SIZEBOX
                         
    Call SetWindowLong(Form.Hwnd, GWL_STYLE, lngStyle)
            
End Sub
Public Function Get_Randomize(ByVal Min As Long, ByVal Max As Long) As Long
    
    Randomize
    Get_Randomize = Rnd * (Max - Min) + Min
    
End Function
Public Function TextFile_WriteText(ByVal TF_TextFile As String, _
                                   ByVal TF_Text As String) As Long
    Dim FN As Integer
        
    On Local Error GoTo Quit
    
    FN = FreeFile
    
    Open TF_TextFile For Output As FN
        Print #FN, TF_Text
    Close FN

Quit:
    TextFile_WriteText = Err.Number

    Err.Clear
    
End Function
Public Function CB_AutoComplete(ComboBox As Object) As Long
    Dim X As Long, Key As Long
    Dim T$, S$
    
    On Local Error GoTo Quit
    
    Key = Keyboard_GetPressedKey
    
    If Key = 8 Or Key = 46 Then CB_AutoComplete = -1: _
                                Exit Function
    
    If CB_AutoCompleteWORK Then CB_AutoComplete = -1: _
                                Exit Function
    
    CB_AutoCompleteWORK = True
    
    T$ = ComboBox.Text
    X = FindPhrase(ComboBox, T$, 1, False)
    
    If X > -1 Then
        S$ = ComboBox.List(X)
        
        If LCase$(S$) <> LCase$(T$) Then ComboBox.Text = S$: _
                                         ComboBox.SelStart = Len(T$): _
                                         ComboBox.SelLength = Len(S$)
    End If
    
    CB_AutoComplete = X
       
Quit:
    If Err.Number <> 0 Then CB_AutoComplete = (Err.Number * -1)
        
    CB_AutoCompleteWORK = False

    Err.Clear
    
End Function
Private Function Keyboard_GetPressedKey() As Long
    Dim P As Long
    
    For P = 0 To 255
        If GetAsyncKeyState(P) = -32767 Then Keyboard_GetPressedKey = P: _
                                             Exit Function
    Next P

End Function
Public Function FindPhrase(LBCB As Object, _
                           ByVal Find As String, _
                           Optional FindAtPosition As Long = -1, _
                           Optional FindExact As Boolean = True) As Long
    Dim P As Long, Index As Long
    Dim R$
        
    On Local Error GoTo Quit
    
    If Not FindExact Then Find = LCase$(Find)
    
    For P = 0 To LBCB.ListCount - 1
        R$ = LBCB.List(P)
        If Not FindExact Then R$ = LCase$(R$)
        
        Index = InStr(R$, Find)

        If FindAtPosition < 0 Then
            If Index > 0 Then FindPhrase = P: _
                              Exit Function
        Else
            If Index = FindAtPosition Then FindPhrase = P: _
                                           Exit Function
        End If
    Next P
    
    FindPhrase = -1
    
Quit:
    If Err.Number <> 0 Then FindPhrase = (Err.Number * -1)
        
    CB_AutoCompleteWORK = False
    
End Function
Public Function Sort(sArray As Variant) As Long
    Dim X As Long
    
    On Local Error GoTo Quit
    
    X = CLng(BubbleSort(sArray))
        
    If X = -1 Then X = 0
        
    Sort = X
        
Quit:
    If Sort = 0 Then Sort = Err.Number
        
    Err.Clear

End Function
Public Function BubbleSort(Feld As Variant) As Boolean
    Dim lb As Long, uB As Long, POS As Long, X As Long
    Dim temp As String
    
    On Local Error GoTo Quit
    
    lb = LBound(Feld)
    uB = UBound(Feld)
    
    While uB > lb
        POS = lb
      
        For X = lb To uB - 1
            If Feld(X) > Feld(X + 1) Then _
                temp = Feld(X + 1): _
                Feld(X + 1) = Feld(X): _
                Feld(X) = temp: _
                POS = X
        Next X
      
        uB = POS
    Wend
    
Quit:
    BubbleSort = (Err.Number = 0)

    Err.Clear
    
End Function
